# Copyright (c) 2022-2023, Arm Limited or its affiliates. All rights reserved.
#
# SPDX-License-Identifier: MIT
---
device_type: n1sdp
job_name: {{ CI_JOB_NAME }}
timeouts:
  job:
    minutes: 120

metadata:
  source: {{ CI_PROJECT_URL }}
  path: .gitlab/lava/n1sdp/acs_suite.yml.j2
  gitlab-job-url: {{ CI_JOB_URL }}

priority: medium
visibility:
  group:
    - cassini

notify:
  criteria:
    status: finished
  callbacks:
    - url: "{{ CI_API_V4_URL }}/projects/{{ CI_PROJECT_ID }}/jobs/{{ TEST_COMPLETE_JOB_ID }}/play"
      method: POST
      token: "{{ LAVA_CALLBACK_TOKEN }}"
      header: "PRIVATE-TOKEN"
      dataset: minimal

context:
  extra_nfsroot_args: ',vers=3'
  extra_kernel_args: rootwait

actions:
#
# Any firmware bundle deployed must be configured to boot automatically without
# intervention. This means "PMIC_FORCE" must be set "TRUE" in the config file
# to be deployed.
#
#
# Deploy a firmware bundle with the customised "uefi.bin" installed. This
# enables an EFI network driver, allowing us to force a TFTP boot from GRUB (assuming cobbler is setup)
#
- deploy:
    namespace: recovery
    timeout:
      minutes: 5
    failure_retry: 2
    to: flasher
    images:
      recovery_image:
        url: {{ LAVA_STATIC_FILES_SERVER_URL }}/downloads/lava/health-checks/n1sdp/4/n1sdp-board-firmware-force-netboot.zip
        compression: zip


- deploy:
    namespace: debian
    to: tftp
    os: debian
    kernel:
      url: {{ LAVA_STATIC_FILES_SERVER_URL }}/downloads/lava/health-checks/n1sdp/4/debian/linux
      type: image
    ramdisk:
      url: {{ LAVA_STATIC_FILES_SERVER_URL }}/downloads/lava/health-checks/n1sdp/4/debian/ramdisk.img
    nfsrootfs:
      url: {{ LAVA_STATIC_FILES_SERVER_URL }}/downloads/lava/health-checks/n1sdp/4/debian/debian-buster-arm64-rootfs.tar.xz
      compression: xz


- boot:
    namespace: recovery
    timeout:
      minutes: 10
    method: minimal
    parameters:
      kernel-start-message: ''
    prompts: ['Cmd>']


- boot:
    namespace: uart1
    method: new_connection
    connection: uart1


- boot:
    namespace: debian
    connection-namespace: uart1
    timeout:
      minutes: 5
    method: grub
    commands: nfs
    prompts:
      - '/ # '


- test:
    namespace: debian
    timeout:
      minutes: 5
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: device-network
            description: '"Test device network connection"'
            os:
              - debian
            scope:
              - functional
          run:
            steps:
              - |
                cat <<- "EOF" > /etc/systemd/network/wired.network
                [Match]
                Name=e*
                [Network]
                DHCP=yes
                KeepConfiguration=dhcp
                [DHCP]
                CriticalConnection=true
                EOF
              - systemctl restart systemd-networkd
              - apt -q update
              - apt -q install -y iputils-ping
              - ping -c 5 {{ LAVA_HOST_IP }} || lava-test-raise "Device failed to reach a remote host ({{ LAVA_HOST_NAME }})"
              - hostname -I | grep -q $(lava-target-ip) # || lava-test-raise "Device is not at assigned IP address"
        from: inline
        name: device-network
        path: inline/device-network.yaml


- test:
    namespace: debian
    timeout:
      minutes: 5
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: install-dependancies
            description: '"Install dependancies for secondary media deployment"'
            os:
              - debian
            scope:
              - functional
          run:
            steps:
              - apt-get update -q
              - apt-get install -qy bmap-tools
        from: inline
        name: install-dependancies
        path: inline/install-dependancies.yaml


#
# Deploy the ACS image and the corresponding bmap file stored as artifacts by the build job
#
- deploy:
    namespace: secondary_media
    connection-namespace: uart1
    timeout:
      minutes: 10
    to: usb
    os: oe
    images:
      image:
        url: "{{ IMAGE_ARTIFACT }}"
        compression: bz2
      bmap:
        url: "{{ BMAP_ARTIFACT }}"
    uniquify: false
    device: usb_storage_device
    writer:
      tool: /usr/bin/bmaptool
      options: copy {DOWNLOAD_URL} {DEVICE}
      prompt: 'bmaptool: info'
    tool:
      prompts: ['copying time: [0-9ms\.\ ]+, copying speed [0-9\.]+ MiB\/sec']


- test:
    namespace: debian
    timeout:
      minutes: 5
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: configure-SCT-test-sequence
            description: '"Configure the SCT sequence file"'
            os:
              - debian
            scope:
              - functional
          run:
            steps:
              - lsblk
              - mkdir acs
              - mount /dev/sda1 acs
              - cd acs
              - cd EFI/BOOT/bbr/SCT/Sequence
              - rm EBBR.seq
              - mv {{ SEQUENCE_FILE }}.seq EBBR.seq
              - sync
        from: inline
        name: configure-SCT-test-sequence
        path: inline/configure-SCT-test-sequence.yaml


#
# Deploy the cassini primary board firmware bundle stored as an artifact by the build job
#
- deploy:
    namespace: recovery
    timeout:
      minutes: 5
    failure_retry: 2
    to: flasher
    images:
      recovery_image:
        url: "{{ FIRMWARE_ARTIFACT }}"
        compression: zip


- boot:
    namespace: secondary_media
    timeout:
      minutes: 100
    method: minimal
    auto_login:
      login_prompt: '/ # '
      username: root
      login_commands:
      - umount /mnt
    prompts:
      - '/ #'


- deploy:
    namespace: recovery
    timeout:
      minutes: 5
    failure_retry: 2
    to: flasher
    images:
      recovery_image:
        url: {{ LAVA_STATIC_FILES_SERVER_URL }}/downloads/lava/health-checks/n1sdp/4/n1sdp-board-firmware-force-netboot.zip
        compression: zip


- boot:
    namespace: debian
    connection-namespace: uart1
    timeout:
      minutes: 5
    method: grub
    commands: nfs
    prompts:
      - '/ # '


- test:
    namespace: debian
    timeout:
      minutes: 5
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: upload-acs-reports
            description: '"Upload ACS reports"'
            os:
              - debian
            scope:
              - functional
          run:
            steps:
              - echo "{{ ARTIFACTORY_HOST_IP }} {{ ARTIFACTORY_HOST_NAME }}" >> /etc/hosts
              - echo "{{ NTP_HOST_IP }} {{ NTP_HOST_NAME }}" >> /etc/hosts
              - apt -q update
              - apt -q install -y curl
              - curl -fL https://getcli.jfrog.io/v2 | sh
              - ./jfrog config add artifactory-aws --interactive=false --artifactory-url={{ ARTIFACTORY_AWS_URL }} --user={{ ARTIFACTORY_USER }} --password={{ ARTIFACTORY_PASS }};
              - lsblk
              - mkdir acs
              - mount /dev/sda2 acs
              - lsblk
              - cd acs
              - |
                cat << EOF > ./upload_spec.json
                {
                  "files": [
                    {
                      "pattern": "acs_results/",
                      "target": "oss-cassini.lava-images-temp/",
                      "flat": "false",
                      "recursive": "true"
                    }
                  ]
                }
                EOF
              - build_name="oss-cassini/{{ CI_PROJECT_PATH }}/{{ CI_JOB_NAME }}"
              - ../jfrog rt upload --spec=upload_spec.json --build-name="${build_name}" --build-number="{{ CI_JOB_ID }}"
              # Collect environment variables and attach them to a build.
              - ../jfrog rt build-collect-env "${build_name}" "{{ CI_JOB_ID }}"
              # Publish build info to Artifactory
              - ../jfrog rt build-publish "${build_name}" "{{ CI_JOB_ID }}"  --build-url="{{ CI_PROJECT_URL }}"
              # Discard builds and artifacts previously published to Artifactory
              - ../jfrog rt build-discard "${build_name}" --max-builds=20 --delete-artifacts --async
        from: inline
        name: upload-acs-reports
        path: inline/upload-acs-reports.yaml
